<!doctype html>
<html lang="en">
 <head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta name="generator" content="Asciidoctor 2.0.12">
  <meta name="author" content="Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation">
  <link rel="icon" type="image/png" href="../../favicon.png">
  <title>Built-in file tools | ToolDef documentation</title>
  <link rel="stylesheet" href="../../assets/asciidoctor-escet-tooldef.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
  <link rel="stylesheet" href="../../assets/styles/asciidoctor-highlightjs-escet.min.css"> <!--
  Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation

  See the NOTICE file(s) distributed with this work for additional
  information regarding copyright ownership.

  This program and the accompanying materials are made available under the terms
  of the MIT License which is available at https://opensource.org/licenses/MIT

  SPDX-License-Identifier: MIT
-->
  <meta name="robots" content="noindex">
  <script type="text/javascript" src="../../assets/asciidoctor-escet-tooldef.js"></script>
 </head>
 <body class="book toc2 toc-left" onload="onLoad()">
  <div id="header">
   <div id="toc" class="toc2">
    <p class="website-link">Part of: <a href="../..">ToolDef website</a></p>
    <div id="toctitle">
     ToolDef documentation
    </div>
    <ul class="sectlevel1">
     <li class="toc-item">
      <div class="toc-item-marker"></div><a href="../../documentation.html">Home</a></li>
     <li class="toc-item">
      <div class="toc-item-marker"></div><a href="../../introduction.html">Introduction</a></li>
     <li class="toc-cur-page-ancestor toc-item toc-item-parent expanded">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../index.html">Language reference</a>
      <ul class="sectlevel2">
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../index.html#syntax">Syntax</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../syntax/lexical.html">Lexical syntax</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../syntax/lexical.html#keywords">Keywords</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../syntax/lexical.html#terminals">Terminals</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../syntax/lexical.html#whitespace">Whitespace</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../syntax/lexical.html#comments">Comments</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../syntax/grammar.html">Grammar</a></li>
        </ul></li>
       <li class="toc-cur-page-ancestor toc-item toc-item-parent expanded">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../index.html#built-in-tools-and-operators">Built-in tools and operators</a>
        <ul class="sectlevel3">
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="operators.html">Built-in operators</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#not-operator">not operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#and-operator">and operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#or-operator">or operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator-unary1">+ operator (unary)</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator-binary1">+ operator (binary)</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator-unary2">- operator (unary)</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator-binary2">- operator (binary)</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator1">* operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator2">/ operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#div-operator">div operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#mod-operator">mod operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator3">&lt; operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator4">&lt;= operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator5">&gt; operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator6">&gt;= operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator7">== operator</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="operators.html#operator8">!= operator</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="data.html">Built-in data tools</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#abs-tool">abs tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#ceil-tool">ceil tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#contains-tool">contains tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#del-tool">del tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#delidx-tool">delidx tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#empty-tool">empty tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#endswith-tool">endswith tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#entries-tool">entries tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#enumerate-tool">enumerate tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#floor-tool">floor tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#fmt-tool">fmt tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#indexof-tool">indexof tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#join-tool">join tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#keys-tool">keys tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#lastindexof-tool">lastindexof tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#ln-tool">ln tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#log-tool">log tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#lower-tool">lower tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#ltrim-tool">ltrim tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#max-tool">max tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#min-tool">min tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#pow-tool">pow tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#range-tool">range tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#replace-tool">replace tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#reverse-tool">reverse tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#round-tool">round tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#rtrim-tool">rtrim tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#size-tool">size tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#sorted-tool">sorted tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#split-tool">split tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#sqrt-tool">sqrt tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#startswith-tool">startswith tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#str-tool">str tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#strdup-tool">strdup tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#subset-tool">subset tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#trim-tool">trim tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#upper-tool">upper tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="data.html#values-tool">values tool</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="io.html">Built-in I/O tools</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="io.html#out-tool">out tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="io.html#err-tool">err tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="io.html#outln-tool">outln tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="io.html#errln-tool">errln tool</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="generic.html">Built-in generic tools</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="generic.html#app-tool">app tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="generic.html#exec-tool">exec tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="generic.html#tooldef-tool">tooldef tool</a></li>
          </ul></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="path.html">Built-in path tools</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="path.html#abspath-tool">abspath tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="path.html#basename-tool">basename tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="path.html#chdir-tool">chdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="path.html#chfileext-tool">chfileext tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="path.html#curdir-tool">curdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="path.html#dirname-tool">dirname tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="path.html#fileext-tool">fileext tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="path.html#hasfileext-tool">hasfileext tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="path.html#pathjoin-tool">pathjoin tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="path.html#scriptpath-tool">scriptpath tool</a></li>
          </ul></li>
         <li class="toc-cur-page toc-item toc-item-parent expanded">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="#">Built-in file tools</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#cpfile-tool">cpfile tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#cpdir-tool">cpdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#diff-tool">diff tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#exists-tool">exists tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#filenewer-tool">filenewer tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#filesize-tool">filesize tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#find-tool">find tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#isdir-tool">isdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#isfile-tool">isfile tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#mkdir-tool">mkdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#mvfile-tool">mvfile tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#mvdir-tool">mvdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#readlines-tool">readlines tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#rmfile-tool">rmfile tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#rmdir-tool">rmdir tool</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#writefile-tool">writefile tool</a></li>
          </ul></li>
        </ul></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../../tools.html">Tooling</a>
      <ul class="sectlevel2">
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../tools.html#command-line">Command line</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../tools.html#eclipse-ide">Eclipse IDE</a></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../../release-notes.html">ToolDef release notes</a>
      <ul class="sectlevel2">
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-3-0-2024-03-31">Version 3.0 (2024-03-31)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-2-0-2023-12-22">Version 2.0 (2023-12-22)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-1-0-2023-09-30">Version 1.0 (2023-09-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-10-2023-06-30">Version 0.10 (2023-06-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-9-2023-03-31">Version 0.9 (2023-03-31)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-8-2022-12-21">Version 0.8 (2022-12-21)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-7-2022-09-30">Version 0.7 (2022-09-30)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-6-2022-07-07">Version 0.6 (2022-07-07)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-5-2022-03-29">Version 0.5 (2022-03-29)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-4-2021-12-17">Version 0.4 (2021-12-17)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-3-2021-10-01">Version 0.3 (2021-10-01)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-2-2021-07-07">Version 0.2 (2021-07-07)</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../../release-notes.html#version-0-1-2021-04-02">Version 0.1 (2021-04-02)</a></li>
      </ul></li>
     <li class="toc-item">
      <div class="toc-item-marker"></div><a href="../../documentation-legal.html">Legal</a></li>
    </ul>
   </div>
  </div>
  <div id="content">
   <div id="breadcrumbs">
    <a class="breadcrumb" href="../../documentation.html">ToolDef documentation</a> &gt; <a class="breadcrumb" href="../index.html">Language reference</a> &gt; <a class="breadcrumb" href="../index.html#built-in-tools-and-operators">Built-in tools and operators</a> &gt; <span class="breadcrumb">Built-in file tools</span>
   </div>
   <h2 id="built-in-file-tools"><a class="anchor" href="#"></a>Built-in file tools</h2>
   <div class="paragraph">
    <p>This page describes the built-in I/O tools:</p>
   </div>
   <div class="ulist">
    <ul>
     <li><p><a href="#cpfile-tool">cpfile</a></p></li>
     <li><p><a href="#cpdir-tool">cpdir</a></p></li>
     <li><p><a href="#diff-tool">diff</a></p></li>
     <li><p><a href="#exists-tool">exists</a></p></li>
     <li><p><a href="#filenewer-tool">filenewer</a></p></li>
     <li><p><a href="#filesize-tool">filesize</a></p></li>
     <li><p><a href="#find-tool">find</a></p></li>
     <li><p><a href="#isdir-tool">isdir</a></p></li>
     <li><p><a href="#isfile-tool">isfile</a></p></li>
     <li><p><a href="#mkdir-tool">mkdir</a></p></li>
     <li><p><a href="#mvfile-tool">mvfile</a></p></li>
     <li><p><a href="#mvdir-tool">mvdir</a></p></li>
     <li><p><a href="#readlines-tool">readlines</a></p></li>
     <li><p><a href="#rmfile-tool">rmfile</a></p></li>
     <li><p><a href="#rmdir-tool">rmdir</a></p></li>
     <li><p><a href="#writefile-tool">writefile</a></p></li>
    </ul>
   </div>
   <div class="sect4">
    <h3 id="cpfile-tool"><a class="anchor" href="#cpfile-tool"></a>cpfile tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool cpfile(string source, string target, bool overwrite = false)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Copies a file from a source location to a target location.</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>source</code>
      </dt>
      <dd>
       <p>The absolute or relative local file system path of the source file. May contain both <code>\</code> and <code>/</code> as file separators.</p>
      </dd>
      <dt class="hdlist1">
       <code>target</code>
      </dt>
      <dd>
       <p>The absolute or relative local file system path of the target file. May contain both <code>\</code> and <code>/</code> as file separators.</p>
      </dd>
      <dt class="hdlist1">
       <code>overwrite</code>
      </dt>
      <dd>
       <p>Whether to overwrite the target file if it already exists.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Runtime errors</em></p>
    </div>
    <div class="ulist">
     <ul>
      <li><p>If the source file does not exist.</p></li>
      <li><p>If the source is a directory rather than a file.</p></li>
      <li><p>If it can not be determined whether the source path refers to a file or a directory.</p></li>
      <li><p>If the target file exists and overwriting is not allowed.</p></li>
      <li><p>If the target file exists and overwriting is allowed, but the target refers to a directory rather than a file.</p></li>
      <li><p>If the target file exists and overwriting is allowed, but it can not be determined whether the target path refers to a file or a directory.</p></li>
      <li><p>If copying the file failed due to an I/O error.</p></li>
     </ul>
    </div>
   </div>
   <div class="sect4">
    <h3 id="cpdir-tool"><a class="anchor" href="#cpdir-tool"></a>cpdir tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool cpdir(string source, string target)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Copies a directory from a source location to a target location. All files and directories in the source directory are copied recursively.</p>
    </div>
    <div class="paragraph">
     <p>If the operation fails, part of the operation may have already been performed.</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>source</code>
      </dt>
      <dd>
       <p>The absolute or relative local file system path of the source directory. All files and directories in the source directory are copied recursively. May contain both <code>\</code> and <code>/</code> as file separators.</p>
      </dd>
      <dt class="hdlist1">
       <code>target</code>
      </dt>
      <dd>
       <p>The absolute or relative local file system path of the target directory. This is the directory in which the contents of the source directory are copied. The source directory itself is not copied, only the files and directories contained in the source directory. May contain both <code>\</code> and <code>/</code> as file separators.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Runtime errors</em></p>
    </div>
    <div class="ulist">
     <ul>
      <li><p>If the source directory does not exist.</p></li>
      <li><p>If the source is a file rather than a directory.</p></li>
      <li><p>If it can not be determined whether the source path refers to a file or a directory.</p></li>
      <li><p>If the target directory already exists.</p></li>
      <li><p>If the target directory doesn’t exist, but one of the ancestors is not a directory.</p></li>
      <li><p>If walking the directory (recursively) fails.</p></li>
      <li><p>If walking the directory (recursively) encounters a file system cycle (due to symbolic links).</p></li>
      <li><p>If a file or (sub-)directory could not be copied due to an I/O error.</p></li>
     </ul>
    </div>
   </div>
   <div class="sect4">
    <h3 id="diff-tool"><a class="anchor" href="#diff-tool"></a>diff tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool bool diff(string file1, string file2, string output = "-", bool missingAsEmpty = false, bool warnOnDiff = false, bool failOnDiff = false)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Computes the differences between two files.</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>file1</code>
      </dt>
      <dd>
       <p>The absolute or relative local file system path of the first file. May contain both <code>\</code> and <code>/</code> as file separators.</p>
      </dd>
      <dt class="hdlist1">
       <code>file2</code>
      </dt>
      <dd>
       <p>The absolute or relative local file system path of the second file. May contain both <code>\</code> and <code>/</code> as file separators.</p>
      </dd>
      <dt class="hdlist1">
       <code>output</code>
      </dt>
      <dd>
       <p>Specify whether/where to write a unified diff if the files differ. Use <code>""</code> to not write a unified diff, <code>"-"</code> to write the unified diff to the standard output stream (stdout), or otherwise an absolute or relative local file system path of the file to which to write the unified diff. May contain both <code>\</code> and <code>/</code> as file separators.</p>
      </dd>
      <dt class="hdlist1">
       <code>missingAsEmpty</code>
      </dt>
      <dd>
       <p>Treat a missing first/second file as empty (<code>true</code>) or as an error (<code>false</code>).</p>
      </dd>
      <dt class="hdlist1">
       <code>warnOnDiff</code>
      </dt>
      <dd>
       <p>Emit a warning for differing files (<code>true</code>) or not (<code>false</code>). If a warning is emitted to the standard error stream (stderr), the unified diff (if enabled) is printed first.</p>
      </dd>
      <dt class="hdlist1">
       <code>failOnDiff</code>
      </dt>
      <dd>
       <p>Treat differing files as an error (<code>true</code>) or not (<code>false</code>). If an error is emitted, the unified diff (if enabled) and warning (if enabled) are printed first.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p><code>true</code> if the files differ, <code>false</code> otherwise.</p>
    </div>
    <div class="paragraph">
     <p><em>Runtime errors</em></p>
    </div>
    <div class="ulist">
     <ul>
      <li><p>If either the first or second file doesn’t exist and <code>missingAsEmpty</code> is disabled.</p></li>
      <li><p>If the first or second file is not a file but a directory.</p></li>
      <li><p>If it can not be determined whether the first or second path refers to a file or a directory.</p></li>
      <li><p>If an I/O error occurs.</p></li>
      <li><p>If the <code>out</code> file exists but is a directory rather than a regular file.</p></li>
      <li><p>If the <code>out</code> file does not exist but cannot be created.</p></li>
      <li><p>If the <code>out</code> file cannot be opened for writing for any other reason.</p></li>
      <li><p>If an I/O error occurs while writing to the <code>out</code> file.</p></li>
      <li><p>If the <code>out</code> file can not be closed.</p></li>
      <li><p>If the files differ and <code>failOnDiff</code> is enabled.</p></li>
     </ul>
    </div>
   </div>
   <div class="sect4">
    <h3 id="exists-tool"><a class="anchor" href="#exists-tool"></a>exists tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool bool exists(string path)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Does a file or directory with the given path exist?</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>path</code>
      </dt>
      <dd>
       <p>The absolute or relative local file system path of the file or directory. May contain both <code>\</code> and <code>/</code> as file separators.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p><code>true</code> if the file or directory exists, <code>false</code> otherwise.</p>
    </div>
   </div>
   <div class="sect4">
    <h3 id="filenewer-tool"><a class="anchor" href="#filenewer-tool"></a>filenewer tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool bool filenewer(string path, string refpath,       bool allowNonExisting = false, bool sameAsNewer = true)
tool bool filenewer(string path, string... refpaths,   bool allowNonExisting = false, bool sameAsNewer = true)
tool bool filenewer(string path, list string refpaths, bool allowNonExisting = false, bool sameAsNewer = true)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Checks whether a file is newer (was modified at a later date/time) than some reference file(s). The minimum modification time difference that can be detected is 1 millisecond.</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>path</code>
      </dt>
      <dd>
       <p>The absolute or relative local file system path of the file for which to check whether it is newer than the reference file(s). May contain both <code>\</code> and <code>/</code> as file separators.</p>
      </dd>
      <dt class="hdlist1">
       <code>refpath</code>, <code>refpaths</code>
      </dt>
      <dd>
       <p>The absolute or relative local file system path of the reference file(s). May contain both <code>\</code> and <code>/</code> as file separators.</p>
      </dd>
      <dt class="hdlist1">
       <code>allowNonExisting</code>
      </dt>
      <dd>
       <p>Whether to allow the first file to not exist (<code>true</code>) or consider it an error if the first file does not exist (<code>false</code>).</p>
      </dd>
      <dt class="hdlist1">
       <code>sameAsNewer</code>
      </dt>
      <dd>
       <p>Whether to treat files with the same last change date as being the same (<code>false</code>) or as newer (<code>true</code>).</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p><code>false</code> if the first file does not exist (if allowed by enabling <code>allowNonExisting</code>), if the first file is older than any the reference files, or if the first file has the same last change date as any of the reference files and <code>sameAsNewer</code> is disabled. <code>true</code> if the first file is newer than all of the reference files, if the first file has the same last change date as some of the reference files and <code>sameAsNewer</code> is enabled and is newer than all of the other reference files, or if the first file has the same last change date as all the reference files and <code>sameAsNewer</code> is enabled.</p>
    </div>
    <div class="paragraph">
     <p><em>Runtime errors</em></p>
    </div>
    <div class="ulist">
     <ul>
      <li><p>If the first file does not exist and <code>allowNonExisting</code> is disabled.</p></li>
      <li><p>If any of the reference files does not exist.</p></li>
      <li><p>If any of the files is a directory rather than a file.</p></li>
      <li><p>If for any of the paths it can not be determined whether the path refers to a file or a directory.</p></li>
      <li><p>If the last change date/time of any of the files can not be determined.</p></li>
     </ul>
    </div>
   </div>
   <div class="sect4">
    <h3 id="filesize-tool"><a class="anchor" href="#filesize-tool"></a>filesize tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool long filesize(string path, bool missingAsZero = false)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Returns the size of the file, in bytes.</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>path</code>
      </dt>
      <dd>
       <p>The absolute or relative local file system path of the file. May contain both <code>\</code> and <code>/</code> as file separators.</p>
      </dd>
      <dt class="hdlist1">
       <code>missingAsZero</code>
      </dt>
      <dd>
       <p>Whether to return 0 if the file does not exist (<code>true</code>) or consider it an error if the file does not exist (<code>false</code>).</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The size of the file in bytes, or <code>0</code> if the file is missing and <code>missingAsZero</code> is enabled.</p>
    </div>
    <div class="paragraph">
     <p><em>Runtime errors</em></p>
    </div>
    <div class="ulist">
     <ul>
      <li><p>If the file does not exist and <code>missingAsZero</code> is disabled.</p></li>
      <li><p>If the file is a directory rather than a file.</p></li>
      <li><p>If it can not be determined whether the path refers to a file or a directory.</p></li>
      <li><p>If the size of the file can not be determined due to an I/O error.</p></li>
     </ul>
    </div>
   </div>
   <div class="sect4">
    <h3 id="find-tool"><a class="anchor" href="#find-tool"></a>find tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool list string find(string path, string pattern = "*", bool recursive = true, bool files = true, bool dirs = true)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Searches a directory for files and/or directories matching a pattern.</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>path</code>
      </dt>
      <dd>
       <p>The absolute or relative local file system path of the directory in which to search. The directory itself is never returned. May contain both <code>\</code> and <code>/</code> as file separators.</p>
      </dd>
      <dt class="hdlist1">
       <code>pattern</code>
      </dt>
      <dd>
       <p>The pattern to use to match files/directories. Is a <a href="https://docs.oracle.com/javase/tutorial/essential/io/fileOps.html#glob">Java NIO glob</a> pattern, that is matched against single file names or single directory names, and never against paths. Pattern <code>"*"</code> matches all files and directories.</p>
      </dd>
      <dt class="hdlist1">
       <code>recursive</code>
      </dt>
      <dd>
       <p>Whether to recursively look in sub-directories.</p>
      </dd>
      <dt class="hdlist1">
       <code>files</code>
      </dt>
      <dd>
       <p>Whether to match files.</p>
      </dd>
      <dt class="hdlist1">
       <code>dirs</code>
      </dt>
      <dd>
       <p>Whether to match directories.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The local file system paths of the matched files and directories, relative against the given root directory from which searching started.</p>
    </div>
    <div class="paragraph">
     <p><em>Runtime errors</em></p>
    </div>
    <div class="ulist">
     <ul>
      <li><p>If the given directory is not found.</p></li>
      <li><p>If the given directory is a file rather than a directory.</p></li>
      <li><p>If the can not be determined whether the given path refers to a file or a directory.</p></li>
      <li><p>If the pattern is invalid.</p></li>
      <li><p>If walking the directory (recursively) fails.</p></li>
      <li><p>If walking the directory (recursively) encounters a file system cycle (due to symbolic links).</p></li>
      <li><p>If the operation fails due to an I/O error.</p></li>
     </ul>
    </div>
   </div>
   <div class="sect4">
    <h3 id="isdir-tool"><a class="anchor" href="#isdir-tool"></a>isdir tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool bool isdir(string path)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Does a directory with the given path exist?</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>path</code>
      </dt>
      <dd>
       <p>The absolute or relative local file system path of the directory. May contain both <code>\</code> and <code>/</code> as file separators.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p><code>true</code> if the directory exists, <code>false</code> if it doesn’t exist or is not a directory.</p>
    </div>
   </div>
   <div class="sect4">
    <h3 id="isfile-tool"><a class="anchor" href="#isfile-tool"></a>isfile tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool bool isfile(string path)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Does a file with the given path exist?</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>path</code>
      </dt>
      <dd>
       <p>The absolute or relative local file system path of the file. May contain both <code>\</code> and <code>/</code> as file separators.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p><code>true</code> if the file exists, <code>false</code> if it doesn’t exist or is not a file.</p>
    </div>
   </div>
   <div class="sect4">
    <h3 id="mkdir-tool"><a class="anchor" href="#mkdir-tool"></a>mkdir tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool mkdir(string path, bool force = false, bool parents = true)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Creates the given directory, and optionally its parents as needed.</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>path</code>
      </dt>
      <dd>
       <p>The absolute or relative local file system path of the directory to create. May contain both <code>\</code> and <code>/</code> as file separators.</p>
      </dd>
      <dt class="hdlist1">
       <code>force</code>
      </dt>
      <dd>
       <p>Whether to skip creating the directory if it already exists (<code>true</code>) or fail if it already exists (<code>false</code>).</p>
      </dd>
      <dt class="hdlist1">
       <code>parents</code>
      </dt>
      <dd>
       <p>Whether to allow creating parents as needed (<code>true</code>) or fail if the parent directory does not exist (<code>false</code>).</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Runtime errors</em></p>
    </div>
    <div class="ulist">
     <ul>
      <li><p>If the directory already exists and <code>force</code> is disabled.</p></li>
      <li><p>If creating the directory or any of its parents fails, due to an I/O error.</p></li>
     </ul>
    </div>
   </div>
   <div class="sect4">
    <h3 id="mvfile-tool"><a class="anchor" href="#mvfile-tool"></a>mvfile tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool mvfile(string source, string target, bool overwrite = false)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Moves a file from a source location to a target location. This can be used to rename a file and/or move it to another directory.</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>source</code>
      </dt>
      <dd>
       <p>The absolute or relative local file system path of the source file. May contain both <code>\</code> and <code>/</code> as file separators.</p>
      </dd>
      <dt class="hdlist1">
       <code>target</code>
      </dt>
      <dd>
       <p>The absolute or relative local file system path of the target file. May contain both <code>\</code> and <code>/</code> as file separators.</p>
      </dd>
      <dt class="hdlist1">
       <code>overwrite</code>
      </dt>
      <dd>
       <p>Whether to overwrite the target file if it already exists.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Runtime errors</em></p>
    </div>
    <div class="ulist">
     <ul>
      <li><p>If the source file does not exist.</p></li>
      <li><p>If the source is a directory rather than a file.</p></li>
      <li><p>If it can not be determined whether the source path refers to a file or a directory.</p></li>
      <li><p>If the target file exist and overwriting is not allowed.</p></li>
      <li><p>If the target file exists and overwriting is allowed, but the target refers to a directory rather than a file.</p></li>
      <li><p>If the target file exists and overwriting is allowed, but it can not be determined whether the target path refers to a file or a directory.</p></li>
      <li><p>If moving the file fails due to an I/O error.</p></li>
     </ul>
    </div>
   </div>
   <div class="sect4">
    <h3 id="mvdir-tool"><a class="anchor" href="#mvdir-tool"></a>mvdir tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool mvdir(string source, string target)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Moves a directory from a source location to a target location. The directory and all files and directories in it are moved recursively.</p>
    </div>
    <div class="paragraph">
     <p>The operation is implemented as a copy from source to target, followed by a remove of the source. If the operation fails, part of the operation may have already been performed.</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>source</code>
      </dt>
      <dd>
       <p>The absolute or relative local file system path of the source directory. The directory itself and all files and directories in it are moved recursively. May contain both <code>\</code> and <code>/</code> as file separators.</p>
      </dd>
      <dt class="hdlist1">
       <code>target</code>
      </dt>
      <dd>
       <p>The absolute or relative local file system path of the target directory. This is the directory into which the contents of the source directory are moved. May contain both <code>\</code> and <code>/</code> as file separators.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Runtime errors</em></p>
    </div>
    <div class="ulist">
     <ul>
      <li><p>If the source directory does not exist.</p></li>
      <li><p>If the source is a file rather than a directory.</p></li>
      <li><p>If it can not be determined whether the source path refers to a file or a directory.</p></li>
      <li><p>If the target directory already exists.</p></li>
      <li><p>If the target directory doesn’t exist but one of the ancestors is not a directory.</p></li>
      <li><p>If walking the directory (recursively) fails.</p></li>
      <li><p>If walking the directory (recursively) encounters a file system cycle (due to symbolic links).</p></li>
      <li><p>If a file or (sub-)directory can not be copied or removed, due to an I/O error.</p></li>
     </ul>
    </div>
   </div>
   <div class="sect4">
    <h3 id="readlines-tool"><a class="anchor" href="#readlines-tool"></a>readlines tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool list string readlines(string path)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Read lines of text from a file. Uses UTF-8 encoding when reading the file.</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>path</code>
      </dt>
      <dd>
       <p>The absolute or relative local file system path of the file to read. May contain both <code>\</code> and <code>/</code> as file separators.</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p>The lines of text from the file.</p>
    </div>
    <div class="paragraph">
     <p><em>Runtime errors</em></p>
    </div>
    <div class="ulist">
     <ul>
      <li><p>If the file does not exist.</p></li>
      <li><p>If the path refers to a directory rather than a file.</p></li>
      <li><p>If it can not be determined whether the path refers to a file or a directory.</p></li>
      <li><p>If for some other reason can not be opened for reading.</p></li>
      <li><p>If an I/O error occurs.</p></li>
      <li><p>If the file can not be closed.</p></li>
     </ul>
    </div>
   </div>
   <div class="sect4">
    <h3 id="rmfile-tool"><a class="anchor" href="#rmfile-tool"></a>rmfile tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool bool rmfile(string path, bool force = false)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Removes a file.</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>path</code>
      </dt>
      <dd>
       <p>The absolute or relative local file system path of the file. May contain both <code>\</code> and <code>/</code> as file separators.</p>
      </dd>
      <dt class="hdlist1">
       <code>force</code>
      </dt>
      <dd>
       <p>Whether to ignore non-existing files (<code>true</code>) or consider it an error (<code>false</code>).</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p><code>true</code> if the file was removed, <code>false</code> if it could not be removed because it did not exist and force is enabled.</p>
    </div>
    <div class="paragraph">
     <p><em>Runtime errors</em></p>
    </div>
    <div class="ulist">
     <ul>
      <li><p>If the file does not exist and <code>force</code> is disabled.</p></li>
      <li><p>If the file is a directory rather than a file.</p></li>
      <li><p>If it can not be determined whether the path refers to a file or a directory.</p></li>
      <li><p>If an I/O error occurs.</p></li>
      <li><p>If the file can not be removed for some other reason.</p></li>
     </ul>
    </div>
   </div>
   <div class="sect4">
    <h3 id="rmdir-tool"><a class="anchor" href="#rmdir-tool"></a>rmdir tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool bool rmdir(string path, bool force = false)</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Removes a directory, recursively.</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>path</code>
      </dt>
      <dd>
       <p>The absolute or relative local file system path of the directory. May contain both <code>\</code> and <code>/</code> as file separators.</p>
      </dd>
      <dt class="hdlist1">
       <code>force</code>
      </dt>
      <dd>
       <p>Whether to ignore non-existing directories (<code>true</code>) or consider it an error (<code>false</code>).</p>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Returns</em></p>
    </div>
    <div class="paragraph">
     <p><code>true</code> if the directory was removed, <code>false</code> if it could not be removed because it did not exist and <code>force</code> is enabled.</p>
    </div>
    <div class="paragraph">
     <p><em>Runtime errors</em></p>
    </div>
    <div class="ulist">
     <ul>
      <li><p>If the directory does not exist and <code>force</code> is disabled.</p></li>
      <li><p>If the directory is a file rather than a directory.</p></li>
      <li><p>If it can not be determined whether the path refers to a file or a directory.</p></li>
      <li><p>If an I/O error occurs.</p></li>
      <li><p>If walking the directory (recursively) fails.</p></li>
      <li><p>If walking the directory (recursively) encounters a file system cycle (due to symbolic links).</p></li>
      <li><p>If the directory or one of its sub-files or sub-directories can not be removed for some other reason.</p></li>
     </ul>
    </div>
   </div>
   <div class="sect4">
    <h3 id="writefile-tool"><a class="anchor" href="#writefile-tool"></a>writefile tool</h3>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-tooldef hljs" data-lang="tooldef">tool writefile(string path, string text,       bool append = false, string newline = "platform")
tool writefile(string path, list string lines, bool append = false, string newline = "platform")</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>Writes text to a file. Uses UTF-8 encoding when writing the file.</p>
    </div>
    <div class="paragraph">
     <p><em>Parameters</em></p>
    </div>
    <div class="dlist">
     <dl>
      <dt class="hdlist1">
       <code>path</code>
      </dt>
      <dd>
       <p>The absolute or relative local file system path of the file. May contain both <code>\</code> and <code>/</code> as file separators.</p>
      </dd>
      <dt class="hdlist1">
       <code>text</code>, <code>lines</code>
      </dt>
      <dd>
       <p>The text or lines of text to write to the file. In case <code>lines</code> are given, a new line will additionally be written after each line of text.</p>
      </dd>
      <dt class="hdlist1">
       <code>append</code>
      </dt>
      <dd>
       <p>Whether to append the lines text to the file if it already exists (<code>true</code>), or overwrite the file if it already exists (<code>false</code>).</p>
      </dd>
      <dt class="hdlist1">
       <code>newline</code>
      </dt>
      <dd>
       <p>Indicates how to handle new lines:</p>
       <table class="tableblock frame-all grid-all stretch">
        <colgroup>
         <col style="width: 16.6666%;">
         <col style="width: 83.3334%;">
        </colgroup>
        <thead>
         <tr>
          <th class="tableblock halign-left valign-top">Value</th>
          <th class="tableblock halign-left valign-top">Effect</th>
         </tr>
        </thead>
        <tbody>
         <tr>
          <td class="tableblock halign-left valign-top"><p class="tableblock"><code>"platform"</code></p></td>
          <td class="tableblock halign-left valign-top"><p class="tableblock">Write the text or lines of text with platform-specific new lines. All new lines in the given <code>text</code> or <code>lines</code> are replaced by the new line of the current platform. The new line of the current platform is also written after each of the <code>lines</code>.</p></td>
         </tr>
         <tr>
          <td class="tableblock halign-left valign-top"><p class="tableblock"><code>"preserve"</code></p></td>
          <td class="tableblock halign-left valign-top"><p class="tableblock">Write the <code>text</code> 'as is'. The new lines as they are in the given <code>text</code> are preserved. Using <code>"preserve"</code> is not supported when writing <code>lines</code>.</p></td>
         </tr>
         <tr>
          <td class="tableblock halign-left valign-top"><p class="tableblock">Any other value</p></td>
          <td class="tableblock halign-left valign-top"><p class="tableblock">Write the text or lines of text with the given new line. All new lines in the given <code>text</code> or <code>lines</code> are replaced by the given new line text. The given new line text is also written after each of the <code>lines</code>.</p></td>
         </tr>
        </tbody>
       </table>
      </dd>
     </dl>
    </div>
    <div class="paragraph">
     <p><em>Runtime errors</em></p>
    </div>
    <div class="ulist">
     <ul>
      <li><p>If the path exists but is a directory rather than a regular file.</p></li>
      <li><p>If the file does not exist, but cannot be created.</p></li>
      <li><p>If the file can not be opened for writing for any other reason.</p></li>
      <li><p>If writing to the file fails due to an I/O error.</p></li>
      <li><p>If closing the file fails.</p></li>
      <li><p>If <code>"preserve"</code> is given for <code>newline</code> when writing <code>lines</code>.</p></li>
     </ul>
    </div>
   </div>
  </div>
  <script src="../../assets/highlight.min.js"></script>
  <script src="../../assets/languages/asciidoc.min.js"></script>
  <script src="../../assets/languages/bash.min.js"></script>
  <script src="../../assets/languages/bnf.min.js"></script>
  <script src="../../assets/languages/c.min.js"></script>
  <script src="../../assets/languages/chi.min.js"></script>
  <script src="../../assets/languages/cif.min.js"></script>
  <script src="../../assets/languages/console.min.js"></script>
  <script src="../../assets/languages/css.min.js"></script>
  <script src="../../assets/languages/dsm.min.js"></script>
  <script src="../../assets/languages/java.min.js"></script>
  <script src="../../assets/languages/javascript.min.js"></script>
  <script src="../../assets/languages/markdown.min.js"></script>
  <script src="../../assets/languages/mcrl2.min.js"></script>
  <script src="../../assets/languages/none.min.js"></script>
  <script src="../../assets/languages/properties.min.js"></script>
  <script src="../../assets/languages/raildiagram.min.js"></script>
  <script src="../../assets/languages/setext.min.js"></script>
  <script src="../../assets/languages/shell.min.js"></script>
  <script src="../../assets/languages/tooldef.min.js"></script>
  <script src="../../assets/languages/xml.min.js"></script>
  <script>
if (!hljs.initHighlighting.called) {
  hljs.initHighlighting.called = true
  ;[].slice.call(document.querySelectorAll('pre.highlight > code')).forEach(function (el) { hljs.highlightElement(el) })
}
</script>
  <script type="text/x-mathjax-config">
MathJax.Hub.Config({
  messageStyle: "none",
  tex2jax: {
    inlineMath: [["\\(", "\\)"]],
    displayMath: [["\\[", "\\]"]],
    ignoreClass: "nostem|nolatexmath"
  },
  asciimath2jax: {
    delimiters: [["\\$", "\\$"]],
    ignoreClass: "nostem|noasciimath"
  },
  TeX: { equationNumbers: { autoNumber: "none" } }
})
MathJax.Hub.Register.StartupHook("AsciiMath Jax Ready", function () {
  MathJax.InputJax.AsciiMath.postfilterHooks.Add(function (data, node) {
    if ((node = data.script.parentNode) && (node = node.parentNode) && node.classList.contains("stemblock")) {
      data.math.root.display = "block"
    }
    return data
  })
})
</script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.9/MathJax.js?config=TeX-MML-AM_HTMLorMML"></script> <!--
  Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation

  See the NOTICE file(s) distributed with this work for additional
  information regarding copyright ownership.

  This program and the accompanying materials are made available under the terms
  of the MIT License which is available at https://opensource.org/licenses/MIT

  SPDX-License-Identifier: MIT
-->
  <div id="footer">
   <div id="footer-text">
    <span>ToolDef documentation</span> | <span>Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation</span> | <span>version v3.0</span><br> <a href="https://www.eclipse.org">Eclipse Home</a> | <a href="https://www.eclipse.org/legal/privacy.php">Privacy Policy</a> | <a href="https://www.eclipse.org/legal/termsofuse.php">Terms of Use</a> | <a href="https://www.eclipse.org/legal/copyright.php">Copyright Agent</a> | <a href="https://www.eclipse.org/legal">Eclipse Legal</a>
   </div>
  </div>
 </body>
</html>